diff --git a/sys/dev/sound/usb/uaudio.c b/sys/dev/sound/usb/uaudio.c
index d47eb86ed271..c202ac581119 100644
--- a/sys/dev/sound/usb/uaudio.c
+++ b/sys/dev/sound/usb/uaudio.c
@@ -368,7 +368,6 @@ struct uaudio_softc_child {
 };
 
 struct uaudio_softc {
-	struct sbuf sc_sndstat;
 	struct sndcard_func sc_sndcard_func;
 	struct uaudio_chan sc_rec_chan[UAUDIO_MAX_CHILD];
 	struct uaudio_chan sc_play_chan[UAUDIO_MAX_CHILD];
@@ -391,7 +390,6 @@ struct uaudio_softc {
 	uint8_t	sc_mixer_iface_index;
 	uint8_t	sc_mixer_iface_no;
 	uint8_t	sc_mixer_chan;
-	uint8_t	sc_sndstat_valid:1;
 	uint8_t	sc_uq_audio_swap_lr:1;
 	uint8_t	sc_uq_au_inp_async:1;
 	uint8_t	sc_uq_au_no_xu:1;
@@ -1293,8 +1291,6 @@ uaudio_detach(device_t dev)
 	if (bus_generic_detach(dev) != 0) {
 		DPRINTF("detach failed!\n");
 	}
-	sbuf_delete(&sc->sc_sndstat);
-	sc->sc_sndstat_valid = 0;
 
 	umidi_detach(dev);
 
@@ -2149,15 +2145,6 @@ uaudio_chan_fill_info_sub(struct uaudio_softc *sc, struct usb_device *udev,
 		if (rate > chan->pcm_cap.maxspeed || chan->pcm_cap.maxspeed == 0)
 			chan->pcm_cap.maxspeed = rate;
 
-		if (sc->sc_sndstat_valid != 0) {
-			sbuf_printf(&sc->sc_sndstat, "\n\t"
-			    "mode %d.%d:(%s) %dch, %dbit, %s, %dHz",
-			    curidx, alt_index,
-			    (ep_dir == UE_DIR_IN) ? "input" : "output",
-				    channels, p_fmt->bPrecision,
-				    p_fmt->description, rate);
-		}
-
 	next_ep:
 		sed.v1 = NULL;
 		ed1 = NULL;
@@ -2230,9 +2217,6 @@ uaudio_chan_fill_info(struct uaudio_softc *sc, struct usb_device *udev)
 	if (channels == 0)
 		channels = channels_max;
 
-	if (sbuf_new(&sc->sc_sndstat, NULL, 4096, SBUF_AUTOEXTEND))
-		sc->sc_sndstat_valid = 1;
-
 	/* try to search for a valid config */
 
 	for (x = channels; x; x--) {
@@ -2263,8 +2247,6 @@ uaudio_chan_fill_info(struct uaudio_softc *sc, struct usb_device *udev)
 		if (x == (channels + 1))
 			x--;
 	}
-	if (sc->sc_sndstat_valid)
-		sbuf_finish(&sc->sc_sndstat);
 }
 
 static void
diff --git a/sys/dev/ste/if_ste.c b/sys/dev/ste/if_ste.c
index 7c7eb02ccfb7..06e25175c617 100644
--- a/sys/dev/ste/if_ste.c
+++ b/sys/dev/ste/if_ste.c
@@ -987,11 +987,6 @@ ste_attach(device_t dev)
 		goto fail;
 
 	ifp = sc->ste_ifp = if_alloc(IFT_ETHER);
-	if (ifp == NULL) {
-		device_printf(dev, "can not if_alloc()\n");
-		error = ENOSPC;
-		goto fail;
-	}
 
 	/* Do MII setup. */
 	phy = MII_PHY_ANY;
diff --git a/sys/dev/stge/if_stge.c b/sys/dev/stge/if_stge.c
index 170d9e4da94c..97c2b751d476 100644
--- a/sys/dev/stge/if_stge.c
+++ b/sys/dev/stge/if_stge.c
@@ -560,12 +560,6 @@ stge_attach(device_t dev)
 	}
 
 	ifp = sc->sc_ifp = if_alloc(IFT_ETHER);
-	if (ifp == NULL) {
-		device_printf(sc->sc_dev, "failed to if_alloc()\n");
-		error = ENXIO;
-		goto fail;
-	}
-
 	if_setsoftc(ifp, sc);
 	if_initname(ifp, device_get_name(dev), device_get_unit(dev));
 	if_setflags(ifp, IFF_BROADCAST | IFF_SIMPLEX | IFF_MULTICAST);
diff --git a/sys/dev/sume/if_sume.c b/sys/dev/sume/if_sume.c
index c478e2343a97..4113af5a48b3 100644
--- a/sys/dev/sume/if_sume.c
+++ b/sys/dev/sume/if_sume.c
@@ -1144,7 +1144,7 @@ check_tx_queues(struct sume_adapter *adapter)
 	}
 }
 
-static int
+static void
 sume_ifp_alloc(struct sume_adapter *adapter, uint32_t port)
 {
 	if_t ifp;
@@ -1152,11 +1152,6 @@ sume_ifp_alloc(struct sume_adapter *adapter, uint32_t port)
 	    M_ZERO | M_WAITOK);
 
 	ifp = if_alloc(IFT_ETHER);
-	if (ifp == NULL) {
-		device_printf(adapter->dev, "cannot allocate ifnet\n");
-		return (ENOMEM);
-	}
-
 	adapter->ifp[port] = ifp;
 	if_setsoftc(ifp, nf_priv);
 
@@ -1182,8 +1177,6 @@ sume_ifp_alloc(struct sume_adapter *adapter, uint32_t port)
 	ifmedia_set(&nf_priv->media, IFM_ETHER | IFM_10G_SR);
 
 	if_setdrvflagbits(ifp, IFF_DRV_RUNNING, 0);
-
-	return (0);
 }
 
 static void
@@ -1453,11 +1446,8 @@ sume_attach(device_t dev)
 		goto error;
 
 	/* Now do the network interfaces. */
-	for (i = 0; i < SUME_NPORTS; i++) {
-		error = sume_ifp_alloc(adapter, i);
-		if (error != 0)
-			goto error;
-	}
+	for (i = 0; i < SUME_NPORTS; i++)
+		sume_ifp_alloc(adapter, i);
 
 	/*  Register stats and register sysctls. */
 	sume_sysctl_init(adapter);
diff --git a/sys/dev/superio/superio.c b/sys/dev/superio/superio.c
index 6333cb06a7c1..ff05d378ce92 100644
--- a/sys/dev/superio/superio.c
+++ b/sys/dev/superio/superio.c
@@ -616,12 +616,9 @@ superio_detect(device_t dev, bool claim, struct siosc *sc)
 	if (superio_table[i].descr != NULL) {
 		device_set_desc(dev, superio_table[i].descr);
 	} else if (sc->vendor == SUPERIO_VENDOR_ITE) {
-		char descr[64];
-
-		snprintf(descr, sizeof(descr),
+		device_set_descf(dev,
 		    "ITE IT%4x SuperIO (revision 0x%02x)",
 		    sc->devid, sc->revid);
-		device_set_desc_copy(dev, descr);
 	}
 	return (0);
 }
diff --git a/sys/dev/ti/if_ti.c b/sys/dev/ti/if_ti.c
index 6f88862d8009..14f7d353303f 100644
--- a/sys/dev/ti/if_ti.c
+++ b/sys/dev/ti/if_ti.c
@@ -2384,11 +2384,6 @@ ti_attach(device_t dev)
 	callout_init_mtx(&sc->ti_watchdog, &sc->ti_mtx, 0);
 	ifmedia_init(&sc->ifmedia, IFM_IMASK, ti_ifmedia_upd, ti_ifmedia_sts);
 	ifp = sc->ti_ifp = if_alloc(IFT_ETHER);
-	if (ifp == NULL) {
-		device_printf(dev, "can not if_alloc()\n");
-		error = ENOSPC;
-		goto fail;
-	}
 	if_sethwassist(ifp, TI_CSUM_FEATURES);
 	if_setcapabilities(ifp, IFCAP_TXCSUM | IFCAP_RXCSUM);
 	if_setcapenable(ifp, if_getcapabilities(sc->ti_ifp));
diff --git a/sys/dev/tsec/if_tsec.c b/sys/dev/tsec/if_tsec.c
index 1c03110e1889..80e42116ed9f 100644
--- a/sys/dev/tsec/if_tsec.c
+++ b/sys/dev/tsec/if_tsec.c
@@ -239,12 +239,6 @@ tsec_attach(struct tsec_softc *sc)
 
 	/* Create network interface for upper layers */
 	ifp = sc->tsec_ifp = if_alloc(IFT_ETHER);
-	if (ifp == NULL) {
-		device_printf(sc->dev, "if_alloc() failed\n");
-		tsec_detach(sc);
-		return (ENOMEM);
-	}
-
 	if_setsoftc(ifp, sc);
 	if_initname(ifp, device_get_name(sc->dev), device_get_unit(sc->dev));
 	if_setflags(ifp, IFF_SIMPLEX | IFF_MULTICAST | IFF_BROADCAST);
diff --git a/sys/dev/uart/uart_dev_quicc.c b/sys/dev/uart/uart_dev_quicc.c
index bc9134d5c676..3481154f7da6 100644
--- a/sys/dev/uart/uart_dev_quicc.c
+++ b/sys/dev/uart/uart_dev_quicc.c
@@ -412,7 +412,6 @@ quicc_bus_param(struct uart_softc *sc, int baudrate, int databits,
 static int
 quicc_bus_probe(struct uart_softc *sc)
 {
-	char buf[80];
 	int error;
 
 	error = quicc_probe(&sc->sc_bas);
@@ -422,8 +421,7 @@ quicc_bus_probe(struct uart_softc *sc)
 	sc->sc_rxfifosz = 1;
 	sc->sc_txfifosz = 1;
 
-	snprintf(buf, sizeof(buf), "quicc, channel %d", sc->sc_bas.chan);
-	device_set_desc_copy(sc->sc_dev, buf);
+	device_set_descf(sc->sc_dev, "quicc, channel %d", sc->sc_bas.chan);
 	return (0);
 }
 
diff --git a/sys/dev/uart/uart_dev_z8530.c b/sys/dev/uart/uart_dev_z8530.c
index 53d70b5f42a5..a2f4580d2b5b 100644
--- a/sys/dev/uart/uart_dev_z8530.c
+++ b/sys/dev/uart/uart_dev_z8530.c
@@ -509,7 +509,6 @@ z8530_bus_param(struct uart_softc *sc, int baudrate, int databits,
 static int
 z8530_bus_probe(struct uart_softc *sc)
 {
-	char buf[80];
 	int error;
 	char ch;
 
@@ -522,8 +521,7 @@ z8530_bus_probe(struct uart_softc *sc)
 
 	ch = sc->sc_bas.chan - 1 + 'A';
 
-	snprintf(buf, sizeof(buf), "z8530, channel %c", ch);
-	device_set_desc_copy(sc->sc_dev, buf);
+	device_set_descf(sc->sc_dev, "z8530, channel %c", ch);
 	return (0);
 }
 
diff --git a/sys/dev/usb/controller/usb_controller.c b/sys/dev/usb/controller/usb_controller.c
index 163ee14bd097..838bd6bf7621 100644
--- a/sys/dev/usb/controller/usb_controller.c
+++ b/sys/dev/usb/controller/usb_controller.c
@@ -135,7 +135,6 @@ DRIVER_MODULE(usbus, octusb, usb_driver, 0, 0);
 
 /* Dual Mode Drivers */
 DRIVER_MODULE(usbus, dwcotg, usb_driver, 0, 0);
-DRIVER_MODULE(usbus, saf1761otg, usb_driver, 0, 0);
 
 /*------------------------------------------------------------------------*
  *	usb_probe
diff --git a/sys/dev/usb/controller/xhci.c b/sys/dev/usb/controller/xhci.c
index 17800dc11d0c..58cca9225bdd 100644
--- a/sys/dev/usb/controller/xhci.c
+++ b/sys/dev/usb/controller/xhci.c
@@ -2,6 +2,7 @@
  * SPDX-License-Identifier: BSD-2-Clause
  *
  * Copyright (c) 2010-2022 Hans Petter Selasky
+ * Copyright (c) 2020-2024 Hiroki Sato <hrs@FreeBSD.org>
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -83,6 +84,7 @@
 
 #include <dev/usb/controller/xhci.h>
 #include <dev/usb/controller/xhcireg.h>
+#include <dev/usb/controller/xhci_dbc.h>
 
 #define	XHCI_BUS2SC(bus) \
 	__containerof(bus, struct xhci_softc, sc_bus)
@@ -154,6 +156,9 @@ struct xhci_std_temp {
 	uint8_t			do_isoc_sync;
 };
 
+static void xhci_debug_reg_read(struct xhci_softc *);
+static void xhci_debug_reg_restore(struct xhci_softc *);
+
 static void	xhci_do_poll(struct usb_bus *);
 static void	xhci_device_done(struct usb_xfer *, usb_error_t);
 static void	xhci_root_intr(struct xhci_softc *);
@@ -311,6 +316,7 @@ xhci_start_controller(struct xhci_softc *sc)
 	uint16_t i;
 
 	DPRINTF("\n");
+	printf("%s called\n", __func__);
 
 	sc->sc_event_ccs = 1;
 	sc->sc_event_idx = 0;
@@ -321,6 +327,10 @@ xhci_start_controller(struct xhci_softc *sc)
 	if (err)
 		return (err);
 
+	if (sc->sc_udbc != NULL) {
+		xhci_debug_reg_restore(sc);
+		xhci_debug_enable(sc->sc_udbc);
+	}
 	/* set up number of device slots */
 	DPRINTF("CONFIG=0x%08x -> 0x%08x\n",
 	    XREAD4(sc, oper, XHCI_CONFIG), sc->sc_noslot);
@@ -569,6 +579,60 @@ xhci_init(struct xhci_softc *sc, device_t self, uint8_t dma32)
 	/* enable 64Kbyte control endpoint quirk */
 	sc->sc_bus.control_ep_quirk = (xhcictlquirk ? 1 : 0);
 
+	/* Check if DbC is available. */
+	{
+		sc->sc_udbc = malloc(sizeof(*sc->sc_udbc), M_DEVBUF, 
+		    M_WAITOK | M_ZERO);
+		sc->sc_udbc->sc_xhci = sc;
+#if 0
+		uint32_t eec = -1;	/* XXX */
+		uint32_t eecp;
+
+		for (eecp = XHCI_HCS0_XECP(temp) << 2;
+		     eecp != 0 && XHCI_XECP_NEXT(eec);
+		     eecp += XHCI_XECP_NEXT(eec) << 2) {
+			eec = XREAD4(sc, capa, eecp);
+
+			if (XHCI_XECP_ID(eec) != XHCI_ID_USB_DEBUG) {
+				device_printf(self,
+				    "looking for DBC(0x0a): %02x\n",
+				    XHCI_XECP_ID(eec));
+				continue;
+			}
+		}
+		if (XHCI_XECP_ID(eec) == XHCI_ID_USB_DEBUG) {
+#else
+		if (xhci_debug_probe(sc->sc_udbc)) {
+#endif
+			struct xhci_debug_reg *r;
+
+			sc->sc_dbc_off = sc->sc_udbc->sc_dbc_off;
+			udbcons_init(sc, self);
+
+			xhci_debug_reg_read(sc);
+			r = &sc->sc_udbc->reg;
+
+			device_printf(self, "DbC found at 0x%04x:\n"
+			    "  ERSTSZ=%04x\n"
+			    "  ERSTBA=0x%08llx\n"
+			    "  ERDP=0x%08llx\n"
+			    "  CP=0x%08llx\n"
+			    "  DDI1=0x%04x\n"
+			    "  DDI2=0x%04x\n",
+				sc->sc_dbc_off,
+				r->erstsz,
+				(unsigned long long)le64toh(r->erstba),
+				(unsigned long long)le64toh(r->erdp),
+				(unsigned long long)le64toh(r->cp),
+				r->ddi1,
+				r->ddi2);
+			device_printf(self, "DbC is %s\n",
+			    (XREAD4(sc, dbc, XHCI_DCCTRL) & XHCI_DCCTRL_DCE)
+				? "running"
+				: "not running");
+		} else
+			device_printf(self, "DbC not available\n");
+	}
 	temp = XREAD4(sc, capa, XHCI_HCSPARAMS1);
 
 	/* get number of device slots */
@@ -4406,3 +4470,39 @@ static const struct usb_bus_methods xhci_bus_methods = {
 	.set_hw_power_sleep = xhci_set_hw_power_sleep,
 	.set_endpoint_mode = xhci_set_endpoint_mode,
 };
+
+static void
+xhci_debug_reg_read(struct xhci_softc *sc)
+{
+	struct xhci_debug_reg *r;
+
+	if (sc->sc_dbc_off == 0)
+		return;
+
+	r = &sc->sc_udbc->reg;
+
+	r->erstsz = XREAD4(sc, dbc, XHCI_DCERSTSZ);
+	r->erstba = XREAD44LH(sc, dbc, XHCI_DCERSTBA);
+	r->erdp = XREAD44LH(sc, dbc, XHCI_DCERDP);
+	r->cp = XREAD44LH(sc, dbc, XHCI_DCCP);
+	r->ddi1 = XREAD4(sc, dbc, XHCI_DCDDI1);
+	r->ddi2 = XREAD4(sc, dbc, XHCI_DCDDI2);
+}
+static void
+xhci_debug_reg_restore(struct xhci_softc *sc)
+{
+	struct xhci_debug_reg *r;
+
+	if (sc->sc_dbc_off == 0)
+		return;
+
+	r = &sc->sc_udbc->reg;
+
+	XWRITE4(sc, dbc, XHCI_DCERSTSZ, r->erstsz);
+
+	XWRITE44LH(sc, dbc, XHCI_DCERSTBA, r->erstba);
+	XWRITE44LH(sc, dbc, XHCI_DCERDP, r->erdp);
+	XWRITE44LH(sc, dbc, XHCI_DCCP, r->cp);
+	XWRITE4(sc, dbc, XHCI_DCDDI1, r->ddi1);
+	XWRITE4(sc, dbc, XHCI_DCDDI2, r->ddi2);
+}
diff --git a/sys/dev/usb/controller/xhci.h b/sys/dev/usb/controller/xhci.h
index 3758815238ad..87b3438ce429 100644
--- a/sys/dev/usb/controller/xhci.h
+++ b/sys/dev/usb/controller/xhci.h
@@ -491,6 +491,8 @@ enum xhci_quirks {
 	XHCI_QUIRK_DMA_32B				= 0x00000002,
 };
 
+struct xhci_debug_softc;
+
 struct xhci_softc {
 	struct xhci_hw_softc	sc_hw;
 	/* base device */
@@ -533,6 +535,8 @@ struct xhci_softc {
 	uint32_t		sc_runt_off;
 	/* offset to doorbell registers */
 	uint32_t		sc_door_off;
+	/* offset to DbC registers */
+	uint32_t		sc_dbc_off;
 
 	/* chip specific */
 	uint16_t		sc_erst_max;
@@ -570,6 +574,9 @@ struct xhci_softc {
 
 	/* XHCI quirks. */
 	uint32_t		sc_quirks;
+
+	/* XHCI DbC */
+	struct xhci_debug_softc	*sc_udbc;
 };
 
 #define	XHCI_CMD_LOCK(sc)	sx_xlock(&(sc)->sc_cmd_sx)
